# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudFunctions.V1.Model.FailurePolicy do
  @moduledoc """
  Describes the policy in case of function's execution failure. If empty, then defaults to ignoring failures (i.e. not retrying them).

  ## Attributes

  *   `retry` (*type:* `GoogleApi.CloudFunctions.V1.Model.Retry.t`, *default:* `nil`) - If specified, then the function will be retried in case of a failure.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :retry => GoogleApi.CloudFunctions.V1.Model.Retry.t() | nil
        }

  field(:retry, as: GoogleApi.CloudFunctions.V1.Model.Retry)
end

defimpl Poison.Decoder, for: GoogleApi.CloudFunctions.V1.Model.FailurePolicy do
  def decode(value, options) do
    GoogleApi.CloudFunctions.V1.Model.FailurePolicy.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudFunctions.V1.Model.FailurePolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
