# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudFunctions.V1.Model.GenerateDownloadUrlResponse do
  @moduledoc """
  Response of `GenerateDownloadUrl` method.

  ## Attributes

  *   `downloadUrl` (*type:* `String.t`, *default:* `nil`) - The generated Google Cloud Storage signed URL that should be used for function source code download.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :downloadUrl => String.t() | nil
        }

  field(:downloadUrl)
end

defimpl Poison.Decoder, for: GoogleApi.CloudFunctions.V1.Model.GenerateDownloadUrlResponse do
  def decode(value, options) do
    GoogleApi.CloudFunctions.V1.Model.GenerateDownloadUrlResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudFunctions.V1.Model.GenerateDownloadUrlResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
