# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudFunctions.V2.Model.GenerateUploadUrlResponse do
  @moduledoc """
  Response of `GenerateSourceUploadUrl` method.

  ## Attributes

  *   `storageSource` (*type:* `GoogleApi.CloudFunctions.V2.Model.StorageSource.t`, *default:* `nil`) - The location of the source code in the upload bucket. Once the archive is uploaded using the `upload_url` use this field to set the `function.build_config.source.storage_source` during CreateFunction and UpdateFunction. Generation defaults to 0, as Cloud Storage provides a new generation only upon uploading a new object or version of an object.
  *   `uploadUrl` (*type:* `String.t`, *default:* `nil`) - The generated Google Cloud Storage signed URL that should be used for a function source code upload. The uploaded file should be a zip archive which contains a function.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :storageSource => GoogleApi.CloudFunctions.V2.Model.StorageSource.t() | nil,
          :uploadUrl => String.t() | nil
        }

  field(:storageSource, as: GoogleApi.CloudFunctions.V2.Model.StorageSource)
  field(:uploadUrl)
end

defimpl Poison.Decoder, for: GoogleApi.CloudFunctions.V2.Model.GenerateUploadUrlResponse do
  def decode(value, options) do
    GoogleApi.CloudFunctions.V2.Model.GenerateUploadUrlResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudFunctions.V2.Model.GenerateUploadUrlResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
