# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudFunctions.V2.Model.ListFunctionsResponse do
  @moduledoc """
  Response for the `ListFunctions` method.

  ## Attributes

  *   `functions` (*type:* `list(GoogleApi.CloudFunctions.V2.Model.Function.t)`, *default:* `nil`) - The functions that match the request.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - A token, which can be sent as `page_token` to retrieve the next page. If this field is omitted, there are no subsequent pages.
  *   `unreachable` (*type:* `list(String.t)`, *default:* `nil`) - Locations that could not be reached. The response does not include any functions from these locations.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :functions => list(GoogleApi.CloudFunctions.V2.Model.Function.t()) | nil,
          :nextPageToken => String.t() | nil,
          :unreachable => list(String.t()) | nil
        }

  field(:functions, as: GoogleApi.CloudFunctions.V2.Model.Function, type: :list)
  field(:nextPageToken)
  field(:unreachable, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.CloudFunctions.V2.Model.ListFunctionsResponse do
  def decode(value, options) do
    GoogleApi.CloudFunctions.V2.Model.ListFunctionsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudFunctions.V2.Model.ListFunctionsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
