# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CloudFunctions.V2.Model.ListRuntimesResponse do
  @moduledoc """
  Response for the `ListRuntimes` method.

  ## Attributes

  *   `runtimes` (*type:* `list(GoogleApi.CloudFunctions.V2.Model.Runtime.t)`, *default:* `nil`) - The runtimes that match the request.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :runtimes => list(GoogleApi.CloudFunctions.V2.Model.Runtime.t()) | nil
        }

  field(:runtimes, as: GoogleApi.CloudFunctions.V2.Model.Runtime, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.CloudFunctions.V2.Model.ListRuntimesResponse do
  def decode(value, options) do
    GoogleApi.CloudFunctions.V2.Model.ListRuntimesResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CloudFunctions.V2.Model.ListRuntimesResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
